import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
// -> jdk1.2 imports
// import javax.swing.*;
// import javax.swing.table.*;
// import javax.swing.event.*; 
import java.sql.*;
import java.lang.reflect.*;
import jdbc.*;

/**
 * Provides the tab showing the database meta-data
 */
class dbmdPanel extends JPanel {

	Connection		con;						// the database connection
	SQLBuilder		parent;						// the parent application
	JTable			outputTable;				// the table for outputting the results
	JScrollPane		scrollpane;					// the scroll pane containing the results table
	Statement		stmt;						// the statement used to make requests
	ResultSet		rs;							// the ResultSet from the last query
	DatabaseMetaData dbmd;						// the data we'll display



	/**
	 *
	 */
	dbmdPanel (SQLBuilder sb) {
		parent = sb;										// save parent application
		setLayout( new BorderLayout() );

		outputTable = new JTable();
		JScrollPane scrollpane = new JScrollPane(outputTable);
		add ( scrollpane, BorderLayout.CENTER );
	} // method dbmdPanel


	/**
	 * Invoked by ConnectionPanel when a database connect takes place.
	 */
	void onConnect (Connection c) {
		try {
			con = c;										// save the Connection
			dbmd = con.getMetaData();						// get the data to be displayed
			outputTable.setModel (new ReflectMetaData(dbmd));
		} catch (Exception e) {
		} // try-catch
	} // method onConnect


} // class dbmdPanel 